/**
 * 图片上传
 * config 基础上传配置
 * xelement 对 元素绑定
 * update  操作图片
 * @param    {string}  addEvent     绑定的对象id
 * @returns  void
 *
 * @date     2016-12-01
 * @author   v1.0.0.0
 */
var ligmbly = (function(document, undefined) {	
	var Server = "http://www.jssdit.com/";
	var	Path = 'Api/Upload/Process?action=appuploadimage';
	var files=[]; //图片存放的数组 可以上传一个，或者多个图片
	ligmblyment = {
		addEvent: function (obj) {
            var cell = window.document.getElementById(obj);	
            cell.addEventListener('tap',function(){
				var btnArray = [{title:"照相机"},{title:"相册"}]; //选择按钮  1 2 3
				plus.nativeUI.actionSheet({
				    title:"请选择",
				    cancel:"取消", // 0
				    buttons:btnArray
				    }, 
				    function(e){
				        var index = e.index; // 
				        switch (index){
				            case 1:
				             	ligmblyment.camera(obj);
				            break;
				            case 2:
								ligmblyment.album(obj);
				            break;
				        }
					}
				);
			});
        },
        //照相机
		camera:function(obj){
			var cmr = plus.camera.getCamera();
			cmr.captureImage(function (p) {
			        plus.io.resolveLocalFileSystemURL( p, function ( entry ) {
			            var img_name = entry.name;//获得图片名称
			            var img_path = entry.toLocalURL();//获得图片路径
			         	update.upload_img(img_path,obj);
			        }, function (e) {
			            console.log( "读取拍照文件错误："+e.message );
			        });
			    }, function (e) {
			        console.log( "失败："+e.message );
			}, {filename:'_doc/camera/',index:1} ); 
		},
		album:function(obj){
			plus.gallery.pick(function(path){
			     update.upload_img(path,obj);
			}, function (e) {
			}, {filter:"image"} );
		}
	};
	update = {
		upload_img:function(p,obj){
			files=[];
		    var n=p.substr(p.lastIndexOf('/')+1);
		    files.push({name:"uploadkey",path:p});
		    //开始上传
		    update.start_upload(obj);
		},
		start_upload:function(obj){
		    if(files.length<=0){
		        plus.nativeUI.alert("没有添加上传文件！");
		        return;
		    }
		    //原生的转圈等待框
		    var wt=plus.nativeUI.showWaiting();  
		    var _server = Server+Path;
		    var task=plus.uploader.createUpload(_server,
		        {method:"POST"},
		        function(t,status){ //上传完成
		            if(status==200){

		                //资源
		                var responseText = t.responseText;
		                //转换成json
		                var json = eval('(' + responseText + ')');
		                var Result = eval('(' + json.Content  + ')');
		                if(Result.State == 0)
		            	{
		            		console.log('success');
		            		//上传成功
		            		//上传文件的信息
			                var files = Result.OriginFileName;
			                //上传成功以后的保存路径
			                var img_urls = Result.Url;
			                $("#"+obj).find("img").attr("src","http://www.jssdit.com/" + img_urls); 
			               
			                mui.toast("上传成功!");
			                //ajax 写入数据库
		            	}
		            	else
		            	{
		            		mui.toast(Result.ErrorMessage)
		            	} 
		                //关闭转圈等待框
		                wt.close();
		            }else{
		                console.log("上传失败："+status);
		                //关闭原生的转圈等待框
		                wt.close();
		            }
		        });
		             
		    task.addData("client","");
		    task.addData("uid",utils.getUid());
		    for(var i=0;i<files.length;i++){
		        var f=files[i];
		        task.addFile(f.path,{key:f.name});
		    }
		    task.start(); 
		}
	},
	utils = {
		getUid:function(){
			return Math.floor(Math.random()*100000000+10000000).toString();
		}
	};
}(ligmbly))